/*
To compile this program, just type "csc employee.cs" in your command prompt; 
this will generate an "Employee.exe" in the same path
(tested with the .NET Framework 2.0)
*/

class Program
{
  static void Main(string[] args)
  {
    try
    {
      if (args.Length < 2)
      {
        throw new System.Exception("Where are the parameters?");
      }
      string name = args[0];
      int age = int.Parse(args[1]);
      Employee employee = new Employee(name, age);
      employee.Greet();
    }
    catch (System.Exception e)
    {
      System.Console.WriteLine("There was an error: {0}", e.Message);
    }
    finally
    {
      System.Console.WriteLine("The program finished!");
    }
  }
}

class Employee
{
  private string name = string.Empty;
  private int age = 0;

  public Employee(string name, int age)
  {
    if (age < 0)
    {
      throw new System.Exception("Cannot be so young!");
    }
    if (age > 130)
    {
      throw new System.Exception("Cannot be so old!");
    }
    this.name = name;
    this.age = age;
  }

  public void Greet()
  {
    System.Console.WriteLine("Hi, my name is {0} and I am {1} years old", 
      this.name, this.age);
  }
}
